import java.awt.event.*;

class Timer {

  TimerRunnable runnable;
  long milliseconds;
  ActionListener listener;

  Timer(long m, ActionListener l) {
    milliseconds = m;
    listener = l;
  }

  public void start() {
    runnable = new TimerRunnable(milliseconds, listener);
    Thread thread = new Thread(runnable);
    thread.start();
  }

  public void stop() {
    if(runnable != null) runnable.setFinished();
    runnable = null;
  }
}
